#ifndef DWGLUE_HPP
  #define DWGLUE_HPP

/**************************************************************************
*                                                                         *
* Name   : cGlue                      ( Implementation:                )  *
*                                                                         *
* Klasse(n) definiert : GLUE_C                                            *
* Objekt(e) deklariert: -                                                 *
*                                                                         *
* Abgeleitet von      : -                                                 *
*                                                                         *
* Aufgabe : Zuordnug  Windowhandle <-> This-Pointer                       *
*                                                                         *
* Include Windows.h first !                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

// --- globale Konstanten ---------------------------------------------

const MaxGlues = 100;


// --- globale Typen --------------------------------------------------

typedef struct { HWND Wnd; void *ThisP; } GLUE_S;


/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : GLUE_C                                                       |
|                                                                         |
+------------------------------------------------------------------------*/

class GLUE_C {

// --- Variablen: -----------------------------------------------------

private:
    int        NGlues;
    GLUE_S     GlueTab[MaxGlues];


protected:

public:

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    GLUE_C();
    virtual ~GLUE_C();

private:

protected:

public:
    BOOL    addGlue (HWND aWnd, void* aThis);
    BOOL    delGlue (HWND aWnd);
    BOOL    delGlue (void* aThis);
    HWND    getWndFromThis (void* aThis);
    void*   getThisFromWnd (HWND aWnd);

}; // class GLUE_C

#endif DWGLUE_HPP
