/**************************************************************************
*                                                                         *
* Name    : cComp3D.cpp                                                   *
* Autor   : Martin Wendt, Dez. '91 bis Mai '92                            *
* Compiler: Borland C++ 3.1                                               *
*           Modell: Large                                                 *
*           FloatingPoint : 80287                                         *
*           Optimize for Speed                                            *
*             ABER Gemeinsame Ausdrcke: LOKAL optimiern                  *
*           Windows explicit functions exported                           *
*                                                                         *
*                                                                         *
* BS      : Windows 3.1 unter DOS 5.0                                     *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include "cTypes.hpp"

#include <string.h>

#include "cGlobal.hpp"
#include "cMainWin.hpp"
#include "cOptions.hpp"
#include "cStatWin.hpp"
#include "cTools.hpp"

// --- lokale Konstanten:----------------------------------------------

// --- lokale Typen: --------------------------------------------------

// --- lokale Variablen: ----------------------------------------------


/*------------------------------------------------------------------------+
|                                                                         |
| Main window                                                             |
|                                                                         |
+------------------------------------------------------------------------*/


int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int cmdShow)
{
    // Nur eine Instanz zulassen:

    if (hPrevInstance) {

        HWND hWnd = FindWindow (COMP3DCLASSNAME, NULL);
        if (hWnd) ShowWindow (hWnd, SW_SHOWNORMAL);
        return -1;
    }

    // Objekte initialisien, MainWindow ffnen:

    Global.init (hInstance, hPrevInstance, lpszCmdLine, cmdShow);

    Global.StatWinP->openDlg();

    // ggf. Kommandozeile auswerten:

    if ( (lpszCmdLine!=NULL) && (strlen (lpszCmdLine)>0) ) {

        strncpy (Global.OptionsP->InFile, lpszCmdLine,
                 sizeof (Global.OptionsP->InFile) );
        Global.OptionsP->makeFNames();
    }

    // Startmen hochbringen:

    if ( ! IsIconic (Global.getMainWnd() ) )
        PostMessage (Global.getMainWnd(), WM_COMMAND, MAIN_CONVREDUC, 0L);

    // Messageloop:

    MSG Msg;

    while ( GetMessage (&Msg, NULL, 0, 0) )
    {
        if ( Global.StatWinP->getDlg()==0 ||
             !IsDialogMessage (Global.StatWinP->getDlg(), &Msg) ) {

            TranslateMessage (&Msg);
            DispatchMessage  (&Msg);
        }
    }
    return Msg.wParam;
}
